enum ReviewServer {
    totd, royal
}

uint cacheMS = 60000;

Json::Value@ lastRespWT;
uint lastRespWTTime = 0;
namespace Live {
    int GetReviewServerWaitTime(ReviewServer server) {
        if (lastRespWTTime + cacheMS < Time::Now || lastRespWT is null) {
            lastRespWTTime = Time::Now;
            @lastRespWT = CallLiveApiPath("/api/token/map-review/" + tostring(server) + "/waiting-time");
        }
        try {
            return int(lastRespWT.Get('seconds'));
        } catch {}
        return -1;
    }

    Json::Value@ lastRespConn;
    uint lastRespConnTime = 0;
    // resp: { joinLink: text, starting: bool, noMap: bool, submissionWaitTimer: integer (seconds) }
    Json::Value@ GetReviewServerConnect(ReviewServer server) {
        if (lastRespConnTime + cacheMS < Time::Now || lastRespConn is null) {
            lastRespWTTime = Time::Now;
            @lastRespConn = CallLiveApiPath("/api/token/map-review/" + tostring(server) + "/connect");
        }
        return lastRespConn;
    }

    /*
        resp: {itemCount: int, submittedMaps: SubmittedMap[]}
        SubmittedMap: {
            "mapUid":"i1bKDUPzqOwcAcOXtCDDyLGCSYm","feedbackCount":22,"creationTimestamp":1699781771,"latestSubmissionTimestamp":1699867257,"nominated":false,"nadeoNote":0,"labels":[],"messagingOpen":false,
            "noteInfo":{"countTotal":22,"average":4.5909,"countStar1":1,"countStar2":1,"countStar3":0,"countStar4":2,"countStar5":18,"countStarMax":18},
            "map":{"uid":"i1bKDUPzqOwcAcOXtCDDyLGCSYm","mapId":"14f0a4d3-846a-4d2f-b900-22a8830fb07b","name":" DTC 3 - Mountains - 08","author":"0a2d1bc0-4aaa-4374-b2db-3d561bdab1c9","submitter":"0a2d1bc0-4aaa-4374-b2db-3d561bdab1c9","authorTime":16085,"goldTime":18000,"silverTime":20000,"bronzeTime":25000,"nbLaps":0,"valid":false,"downloadUrl":"https:\/\/prod.trackmania.core.nadeo.online\/storageObjects\/bf717832-b877-4249-b800-e6417e5286e8","thumbnailUrl":"https:\/\/prod.trackmania.core.nadeo.online\/storageObjects\/26e7d791-4329-4a9b-aae9-8385957f65d3.jpg","uploadTimestamp":1699926272,"updateTimestamp":1699926273}
        }
    */
    Json::Value@ GetReviewServerSubmitted(ReviewServer server, bool withFeedback = true, bool withMapInfo = true, uint length = 10, uint offset = 0) {
        return CallLiveApiPath("/api/token/map-review/" + tostring(server) + "/submitted-map?withFeedback="+withFeedback+"&withMapInfo="+withMapInfo+"&"+LengthAndOffset(length, offset));
    }
}
