[Setting category="General" name="Show Current Queue in Menu"]
bool S_ShowQueueTimeInMenu = true;

// queue time format
enum QTF {
    Minutes_To_Wait, Maps_In_Queue
}
[Setting category="General" name="Menu Review Queue Format"]
QTF S_MenuQueueTimeFormat = QTF::Minutes_To_Wait;

[Setting category="General" name="Menu Review Queue Type" description="takes a few min to update"]
ReviewServer S_DefaultReviewType = ReviewServer::totd;



[Setting category="General" name="Log Level"]
#if DEV
LogLevel S_LogLevel = LogLevel::Trace;
#else
LogLevel S_LogLevel = LogLevel::Info;
#endif


[Setting hidden]
string S_JsonPinnedMapUids = "[]";



// [SettingsTab name="Pinned Maps" icon="MapPin" order="10"]
void RenderSettings_PinnedMaps() {
    auto pinned = S_PinnedMapUids;
    UI::Text("# Pinned Maps: " + pinned.Length);
    if (UI::Button(Icons::Plus + " Pinned Map##add-ppinned-map")) {
        pinned.InsertLast("");
    }
    if (UI::BeginChild("pinned map list")) {
        if (UI::BeginTable("pinned maps table", 6)) {
            UI::TableSetupColumn("##ix", UI::TableColumnFlags::WidthFixed, 40.);
            UI::TableSetupColumn("UID", UI::TableColumnFlags::WidthStretch, 1.);
            UI::TableSetupColumn("Name", UI::TableColumnFlags::WidthStretch, 1.);
            UI::TableSetupColumn("Subm. Date", UI::TableColumnFlags::WidthFixed, 60.);
            UI::TableSetupColumn("##space", UI::TableColumnFlags::WidthStretch, .1);
            UI::TableSetupColumn("Buttons", UI::TableColumnFlags::WidthFixed, 40.);

            UI::TableHeadersRow();

            bool anyChanged = false;
            int rmIx = -1;

            UI::ListClipper clip(pinned.Length);
            while (clip.Step()) {
                for (int i = clip.DisplayStart; i < clip.DisplayEnd; i++) {
                    UI::PushID("pinned-" + i);

                    UI::TableNextRow();
                    UI::TableNextColumn();
                    // ix
                    UI::AlignTextToFramePadding();
                    UI::Text("" + (i + 1) + ".");

                    UI::TableNextColumn();
                    // uid entry
                    bool changed;
                    pinned[i] = UI::InputText("##map-uid-" + i, pinned[i], changed);
                    if (changed) anyChanged = true;

                    UI::TableNextColumn();
                    // name
                    GetCachedMapName(pinned[i]);

                    UI::TableNextColumn();
                    // submission date
                    GetCachedSubmissionDate(pinned[i]);

                    UI::TableNextColumn();
                    UI::TableNextColumn();
                    // buttons
                    if (UI::Button(Icons::TrashO + "##rm-pin-map-" + i)) {
                        rmIx = i;
                    }

                    UI::PopID();
                }
            }

            if (rmIx >= 0) {
                pinned.RemoveAt(rmIx);
            }

            if (anyChanged) {
                startnew(OnPinnedMapsChanged);
            }

            UI::EndTable();
        }
    }
    UI::EndChild();
}


void OnPinnedMapsChanged() {
    // validate uids
    // if new uid get info?
}




string[] _S_PinnedMapUids = {};
bool loadedPinnedMaps = false;

void LoadPinnedMaps() {
    try {
        _S_PinnedMapUids.RemoveRange(0, _S_PinnedMapUids.Length);
        auto arr = Json::Parse(S_JsonPinnedMapUids);
        if (arr.GetType() != Json::Type::Array) throw("not a json array");
        for (uint i = 0; i < arr.Length; i++) {
            _S_PinnedMapUids.InsertLast(arr[i]);
        }
    } catch {
        warn("exception loading maps: " + getExceptionInfo());
    }
    loadedPinnedMaps = true;
}

string[]@ S_PinnedMapUids {
    get {
        if (!loadedPinnedMaps) {
            LoadPinnedMaps();
        }
        return _S_PinnedMapUids;
    }
}

void SavePinnedMapUids() {
    S_JsonPinnedMapUids = Json::Write(S_PinnedMapUids.ToJson());
    startnew(SaveSettingsIn20s);
}

uint lastSaveSettingsDelayedCall = 0;
void SaveSettingsIn20s() {
    auto calledAt = Time::Now;
    lastSaveSettingsDelayedCall = calledAt;
    sleep(20000);
    if (lastSaveSettingsDelayedCall == calledAt) {
        Meta::SaveSettings();
    }
}
